from lostsky.worldmap.event import BattleEvent
from lostsky.battle.mapdata import MapData
from lostsky.battle.mapobj import SpiritSourcePoint
from lostsky.battle.mapaction import MapActionEvent, TurnNumTrigger

class Mission(BattleEvent):
    
    def __init__(self):
        # Event Data
        name = 'Sandbox Mission'
        location = 'Central Forest'
        id_string = 'CH0ST1'
        prereqs = []
        auto_signup = True
        cancellable = True
        show_rewards = True
        desc = "This is a testing mission for trying out new features."
        
        BattleEvent.__init__(self, name, location,
                             id_string, prereqs, 
                             auto_signup, cancellable, 
                             show_rewards, desc)
        
        # Map Data
        map_name = 'map1.txt'
        mission_type = 'battle'
        objective = {'type':'Defeat All',
                     'desc':'Defeat All Enemies'
                     } 
        
        deploy_data = {'enable':True,
                       'max_units':6,
                       'preset_units':{},
                       'boxes':[(5,13,4,3)]
                       }
        reward_list = [('spell_action','Rice Cake')
                   ]
                
        # Enemy Unit Data
        enemy_unit_data = [{'template_name': 'Fairy',
                                'unit_name': 'Fairy A',
                                    'level': 1
                                },
                            #
                            
                            ]
        
        initial_spells = {'Fairy A':['Fireball'],
                          #'Fairy B':['Healing Drop'],
#                          'Fairy D':['Fireball'],
#
                            }
        initial_traits = {'Fairy A':[]}
        initial_ai_states = {'Fairy A':'Defend',
                             #'Fairy B':'HealerStandby'
#                             'Fairy D':'Attack',
#
                            }
        initial_locations = {'Fairy A':(1,15),
                             #'Fairy B':(2,15),
#                             'Fairy D':(8,11),
                             }
        reserve_units = []#[list of unit names to deploy later in mission]
        all_landmarks = []
#        all_landmarks = [{'name':'Statue 1',
#                          'id_string':'tombstone',
#                          'location':(5,16)},
#                          {'name':'Statue 2',
#                          'id_string':'tombstone',
#                          'location':(6,11)},
#                          {'name':'Statue 3',
#                          'id_string':'tombstone',
#                          'location':(7,11)},
#                          {'name':'Torii 1',
#                          'id_string':'small_torii',
#                          'location':(10,10)},
#                          {'name':'LP 1',
#                          'id_string':'lilypad',
#                          'location':(6,18)},
#                          {'name':'LP 2',
#                          'id_string':'lilypad',
#                          'location':(8,19)},
#                          {'name':'LP 3',
#                          'id_string':'lilypad',
#                          'location':(9,18)},
#                         ]
    
        required_starters = ['Youmu', 'Keine']
        pre_mission_MAE = PreMissionMAE()
        mid_mission_MAE_list = []
        required_survivors = ['Youmu']
        post_mission_MAE = PostMissionMAE()
    
        self.map_data = MapData(map_name, mission_type, objective,
                                deploy_data, reward_list, enemy_unit_data,
                                initial_spells, initial_traits, initial_ai_states,
                                initial_locations, reserve_units, all_landmarks,
                                required_starters, pre_mission_MAE, mid_mission_MAE_list,
                                required_survivors, post_mission_MAE) 

class PreMissionMAE(MapActionEvent):
    
    def __init__(self):
        triggers = []
        MapActionEvent.__init__(self,triggers)
        
    def execute(self):
        """
        Prologue event 
        """

        self.center_on('Youmu')
#        self.add_temporary_ally('Momiji')
#        self.set_spirit_charge('Youmu', 825)
#        self.assign_spell('Momiji', 'Spirit Recharge')
#        self.set_unit_pos('Momiji', (5,10))

        self.say('Hi', None, None)
        pass
        
        
class PostMissionMAE(MapActionEvent):
    def __init__(self):
        # Triggers on turn 2
        triggers = []
        MapActionEvent.__init__(self,triggers)
    
    def execute(self):
        self.center_on('Youmu')
        self.say("Mission is Over!",'Youmu',"Youmu")