'''
Created on Feb 26, 2011

@author: Fawkes
'''
from lostsky.worldmap.event import BattleEvent
from lostsky.battle.mapdata import MapData
from lostsky.battle.mapaction import MapActionEvent, TurnNumTrigger, UnitAliveTrigger

class Mission(BattleEvent):
    
    def __init__(self):
        # Event Data
        name = 'Kotone\'s Schemes'
        location = 'Central Forest'
        id_string = 'CH2SQ1'
        prereqs = ['CH2ST2']
        auto_signup = False
        cancellable = True
        show_rewards = True
        desc = "Some of my bug friends are still stuck in the forest and would like to leave, but I haven't been able to get back to help them. I've heard rumors that the Kodama Lord Kotone has been gathering a large group of fairies and tree youkai to help her bully those in the forest who won't join them. Kotone is known to be a very impatient Kodama Lord, so it shouldn't take much to wreck her plans. Please disrupt this gathering and give my friends a chance to escape. I promise to reward you with a few treasures that I found in the forest. --Wriggle Nightbug"
        
        BattleEvent.__init__(self, name, location,
                             id_string, prereqs, 
                             auto_signup, cancellable, 
                             show_rewards, desc)
        
        # Map Data
        map_name = 'ch1st2b.txt'
        mission_type = 'battle'
        objective = {'type':'Defeat All',
                     'desc':'Defeat all enemies!'
                     }   
        
        deploy_data = {'enable':True,
                       'max_units':8,
                       'preset_units':{},
                       'boxes':[(26, 24, 4, 2)]
                       }

        reward_list = [('spell_action','Shimmering Stars'),
                       ('treasure','synth_fire'),
                       ('treasure','synth_metal'),
                       ('treasure','synth_earth'),
                      ]
                
        # Enemy Unit Data
        enemy_unit_data = [
                           
                           {'template_name': 'Walking Tree',
                                'unit_name': 'Walking Tree A',
                                    'level': 6},
                           {'template_name': 'Walking Tree',
                                'unit_name': 'Walking Tree B',
                                    'level': 6},
                           {'template_name': 'Walking Tree',
                                'unit_name': 'Walking Tree C',
                                    'level': 6},
                           {'template_name': 'Walking Tree',
                                'unit_name': 'Walking Tree D',
                                    'level': 6},
                           {'template_name': 'Walking Tree',
                                'unit_name': 'Walking Tree E',
                                    'level': 6},
                           {'template_name': 'Walking Tree',
                                'unit_name': 'Walking Tree F',
                                    'level': 6},
                           {'template_name': 'Walking Tree',
                                'unit_name': 'Walking Tree G',
                                    'level': 6},
                           {'template_name': 'Walking Tree',
                                'unit_name': 'Walking Tree H',
                                    'level': 6},
                           {'template_name': 'Walking Tree',
                                'unit_name': 'Walking Tree I',
                                    'level': 6},
                                    
                                    
                           {'template_name': 'Healer Fairy',
                                'unit_name': 'Healer Fairy A',
                                    'level': 6},
                           {'template_name': 'Healer Fairy',
                                'unit_name': 'Healer Fairy B',
                                    'level': 6},
                           {'template_name': 'Healer Fairy',
                                'unit_name': 'Healer Fairy C',
                                    'level': 6},
                                    
                           
                           {'template_name': 'Fairy',
                                'unit_name': 'Fairy Captain',
                                    'level': 7},
                           {'template_name': 'Fairy',
                                'unit_name': 'Dazzling Fairy',
                                    'level': 5},
                           {'template_name': 'Fairy',
                                'unit_name': 'Cosmic Fairy',
                                    'level': 5},
                           {'template_name': 'Fairy',
                                'unit_name': 'Ninja Fairy',
                                    'level': 5},
                           {'template_name': 'Fairy',
                                'unit_name': 'Sealing Fairy',
                                    'level': 5},
                           {'template_name': 'Fairy',
                                'unit_name': 'Toxic Fairy',
                                    'level': 5},
                                    
                           {'template_name': 'Wind Weasel',
                                'unit_name': 'Wind Weasel A',
                                    'level': 6},
                           {'template_name': 'Wind Weasel',
                                'unit_name': 'Wind Weasel B',
                                    'level': 6},
                           {'template_name': 'Wind Weasel',
                                'unit_name': 'Wind Weasel C',
                                    'level': 6},
 
 
                           {'template_name': 'Kotone',
                                'unit_name': 'Kotone',
                                    'level': 9},
                           
                          ]
        
        initial_spells = {
                          'Fairy Captain':['Holy Amulet'],
                          'Kotone':['Leaf Crystal'],
                          
                          'Dazzling Fairy':['Shimmering Stars'],
                          'Ninja Fairy':['Feather Pin'],
                          'Cosmic Fairy':['Stardust'],
                          'Toxic Fairy':['Poison Dust'],
                          'Sealing Fairy':['Spirit Break'],
                          
                          'Wind Weasel A':['Dagger Throw'],
                          'Wind Weasel B':['Dagger Throw'],
                          'Wind Weasel C':['Dagger Throw'],
                          
                          'Walking Tree D':['Leaf Crystal'],
                          'Walking Tree E':['Leaf Crystal'],
                          'Walking Tree F':['Leaf Crystal'],
                          'Walking Tree G':['Leaf Crystal'],
                          'Walking Tree H':['Leaf Crystal'],
                          'Walking Tree I':['Leaf Crystal'],
                          
                          'Healer Fairy A':['Healing Drop'],
                          'Healer Fairy B':['Healing Drop'],
                          'Healer Fairy C':['Healing Drop'],
                          
                          }
                          
        initial_traits = {}

        initial_ai_states = {'Fairy Captain':'Attack',
                          'Kotone':'Attack',
                          'Walking Tree D':'Attack',
                          'Walking Tree E':'Attack',
                          'Walking Tree F':'Attack',
                          'Walking Tree G':'Attack',
                          'Walking Tree H':'Attack',
                          'Walking Tree I':'Attack',
                          
                          'Wind Weasel A':'Attack',
                          'Wind Weasel B':'Attack',
                          'Wind Weasel C':'Attack',
                          
                          
                          'Cosmic Fairy':'Attack',
                          'Sealing Fairy':'Attack',
                          'Ninja Fairy':'Attack',
                          'Dazzling Fairy':'Attack',
                          'Toxic Fairy':'Attack',
                          
                          'Healer Fairy A':'HealerStandby',
                          'Healer Fairy B':'HealerStandby',
                          'Healer Fairy C':'HealerStandby',
                          
                          }
        
        initial_locations = {'Marisa':(26,24),
                             'Reimu':(26,25),
                             'Youmu':(27,23),
                             'Ran':(28,24),
                             'Chen':(28,25),
                             'Keine':(27,25),
                             
                             'Fairy Captain':(11,4),
                             'Kotone':(12,4),
                             'Walking Tree A':(14,3),
                             'Walking Tree B':(14,4),
                             'Walking Tree C':(14,5),
                             
                             
                             'Wind Weasel A':(23,9),
                             'Wind Weasel B':(21,8),
                             'Wind Weasel C':(25,8),
                             'Healer Fairy A':(23,8),
                             
                             'Toxic Fairy':(9,21),
                             'Dazzling Fairy':(11,20),
                             'Healer Fairy B':(11,22),
                             
                             
                             }
        reserve_units = ['Healer Fairy C',
                         
                         'Walking Tree D',
                         'Walking Tree E',
                         'Walking Tree F',
                         'Walking Tree G',
                         'Walking Tree H',
                         'Walking Tree I',
                         'Sealing Fairy',
                         'Ninja Fairy',
                         'Cosmic Fairy',
                         ]
        all_landmarks = [{'name':'M1',
                          'id_string':'mushroom',
                          'location':(10,11)},
                         {'name':'M2',
                          'id_string':'mushroom',
                          'location':(8,8)},
                         {'name':'M3',
                          'id_string':'mushroom',
                          'location':(23,8)},
                         {'name':'M4',
                          'id_string':'mushroom',
                          'location':(18,10)},
                         {'name':'M5',
                          'id_string':'mushroom',
                          'location':(24,21)},
                         {'name':'M6',
                          'id_string':'mushroom',
                          'location':(11,18)},
                         {'name':'M7',
                          'id_string':'mushroom',
                          'location':(14,22)},
                         {'name':'M8',
                          'id_string':'mushroom',
                          'location':(13,27)},
                         {'name':'CB1',
                          'id_string':'cherryblossom_tree',
                          'location':(27,23)},
                         ]
    
        required_starters = ['Youmu','Chen','Ran', 'Reimu', 'Marisa', 'Keine']
        pre_mission_MAE = PreMissionMAE()
        mid_mission_MAE_list = [Turn2MAE(),
                                Turn6MAE(),
                                FiveFairiesDeadMAE()
                                ]
        post_mission_MAE = PostMissionMAE()
        required_survivors = ['Youmu', 'Chen', 'Ran', 'Marisa', 'Reimu', 'Keine', 'Fairy Captain']
    
        self.map_data = MapData(map_name, mission_type, objective,
                                deploy_data, reward_list, enemy_unit_data,
                                initial_spells, initial_traits, initial_ai_states,
                                initial_locations, reserve_units, all_landmarks,
                                required_starters, pre_mission_MAE, mid_mission_MAE_list,
                                required_survivors, post_mission_MAE) 

class PreMissionMAE(MapActionEvent):
    
    def __init__(self):
        triggers = []
        MapActionEvent.__init__(self,triggers)
        
    def execute(self):
        """
        Introductory Scene: Kotone gathers her forces
        """
        
        self.set_cursor_state(False)
        self.set_stats_display(False)
        self.play_music('battle03')
 
        # Kotone and party prepares for battle
        self.center_on('Kotone')
        self.say("You there, Fairy Captain!",
                 "Kotone",
                 'Kotone')
        self.startle('Fairy Captain')
        self.say("Yes, Kotone!",
                 "Fairy Captain",
                 "Fairy")
        self.emote('Kotone', 'annoyed')
        self.say("Who are we waiting on?",
                 "Kotone",
                'Kotone')
        self.say("Haruna's sending a few more trees from the swamp region to help us. We're also waiting on some of our fairy companions. They'll arrive in a few hours.",
                 "Fairy Captain",
                 "Fairy")
        self.center_on('Youmu')
        self.say("Wriggle was right. This Kodama Lord is certainly gathering a lot of support here.",
                 "Youmu",
                 "Youmu")
        self.say("Let's listen in on what they're up to.",
                 "Ran",
                 "Ran")
        self.say("Where could they be going?",
                 "Marisa",
                 "Marisa")
        self.center_on('Kotone')
        
        self.say("Since Ayaka just assigned me to this mission without too much information, what can you tell me about the girl we're visiting?",
                 "Kotone",
                 'Kotone')
        self.say("She's a solitary sorceress. A master of puppetry and magic. Her name is Alice Margatroid.",
                 "Fairy Captain",
                 "Fairy")
        self.say("Puppets? Those don't seem to be any match for us if it comes to a fight.",
                 "Kotone",
                 'Kotone')
        self.say("So we'll definitely be fighting her?",
                 "Fairy Captain",
                 "Fairy")
        self.say("You were originally with Haruna, Kodama Lord of the Northern Forests. I know that she always prefers the more peaceful path, but things in Gensokyo are settled with fights rather than talk.",
                 "Kotone",
                 'Kotone')

        # Kotone gets impatient
        self.emote('Kotone', 'dotdotdot')
        self.say("(How much longer do I have to wait? Maybe I should just go now.)",
                 "Kotone",
                 'Kotone')
        self.emote('Kotone', 'dotdotdot')


        self.say("Fairy Captain, stay behind and gather allies. Then join me at the magician Alice's house.",
                 "Kotone",
                 'Kotone')
        self.say("You're not going to wait for them?",
                 "Fairy Captain",
                 "Fairy")
        self.say("I'll take a few of those trees that Haruna provided. I already sent some more ahead to meet us there. This should be plenty to take on that one sorceress. By the time you guys get there, we should have enough to easily take on one puny magician.",
                 "Kotone",
                 'Kotone')
        self.say("Yes, Kotone!",
                 "Fairy Captain",
                 "Fairy")

        # Kotone and a few walking trees withdraw from the battle map
        self.startle('Kotone')        
        self.say("Okay, let's go!",
                 "Kotone",
                 'Kotone')
        self.move_unit('Kotone', (13,-1))
        self.move_unit('Walking Tree A', (14,-1))
        self.move_unit('Walking Tree B', (14,-1))
        self.move_unit('Walking Tree C', (14,-1))
        
        self.kill_unit('Kotone')
        self.kill_unit('Walking Tree A')
        self.kill_unit('Walking Tree B')
        self.kill_unit('Walking Tree C')

        # Party plans out what to do next
        self.center_on('Youmu')
        
        self.startle('Marisa')
        self.emote('Marisa','exclamation')
        self.say("Great... they're after Alice! We have to follow her. Come on, let's go!",
                 "Marisa",
                 "Marisa")
        self.say("Hold on, Marisa. Kotone's expecting these guys as reinforcements, right? Kotone's severely underestimated Alice's strength if she's only taking a handful of trees.",
                 "Ran",
                 "Ran")
        self.say("Alice has always been a loner. If it's her against Kotone and those trees, I'm not sure if she'll be okay.",
                 "Marisa",
                 "Marisa")
        self.say("Alice can take care of herself. She's as experienced as we are.",
                 "Reimu",
                 "Reimu")
        self.say("Do you have a plan?",
                 "Chen",
                 "Chen")
        self.say("I'd like to suggest defeating the reinforcements when they gather here. This is going to be a tough battle. We can't attack too quickly or we'll scare them off.",
                 "Ran",
                 "Ran")
        self.say("So right as the last moment, we'll launch our attack.",
                 "Keine",
                 "Keine")
        self.say("And this distraction will definitely give enough time for Wriggle's friends to escape.",
                 "Chen",
                 "Chen")
        self.say("Let's go with Ran's plan. We'll wipe out all these reinforcements, and Kotone will have no backup when we do fight her at Alice's house.",
                 "Youmu",
                 "Youmu")
        self.say("Marisa, don't worry about Alice. We can head there right after this.",
                 "Reimu",
                 "Reimu")
        self.emote('Marisa', 'dotdotdot')


        # Rest of the enemy team arrives
        self.fade_to_color('black', 1)
        self.deploy_unit('Cosmic Fairy', (13, 21))
        self.deploy_unit('Ninja Fairy', (10, 23))
        self.deploy_unit('Sealing Fairy', (12, 23))
        
        self.deploy_unit('Healer Fairy C', (14,5))
        self.deploy_unit('Walking Tree D', (12,5))
        self.deploy_unit('Walking Tree E', (12,6))
        self.deploy_unit('Walking Tree F', (12,7))
        self.deploy_unit('Walking Tree G', (16,5))
        self.deploy_unit('Walking Tree H', (16,6))
        self.deploy_unit('Walking Tree I', (16,7))
                         
        self.fade_from_color('black', 1)
        
        self.center_on('Fairy Captain')
        self.emote('Fairy Captain', 'annoyed')
        self.say("Aah! It took you long enough!",
                 "Fairy Captain",
                 "Fairy")
        self.say("Don't blame me. Haruna took long enough to get out of hibernation and had to wake all her trees up.",
                 "Healer Fairy",
                 "Healer Fairy")
        self.say("So we have your group, the Five Fantastic Forest Fairies, and the weasels. Shall we meet up with Kotone then?",
                 "Fairy Captain",
                 "Fairy")

        # Fairy units introduce themselves: introduction of a bunch of status effects
        self.set_cursor_state(True)
        self.center_on('Cosmic Fairy')
        self.say("Oh! Finally! We get to do some fighting at last!",
                  'Cosmic Fairy', 'Fairy')
        self.center_on('Ninja Fairy')
        self.say("Everyone practiced their abilities?",
                  'Ninja Fairy', 'Fairy')

        self.center_on('Dazzling Fairy')
        self.startle('Dazzling Fairy')
        self.emote('Dazzling Fairy', 'exclamation')
        self.say("You got it, boss! My magic will leave them dizzy. They'll never be able to aim properly!",
                  'Dazzling Fairy', 'Fairy')

        self.center_on('Sealing Fairy')
        self.startle('Sealing Fairy')
        self.emote('Sealing Fairy', 'exclamation')
        self.say("I'll drain the spiritual power right out of them.",
                 'Sealing Fairy', 'Fairy')

        self.center_on('Toxic Fairy')
        self.startle('Toxic Fairy')
        self.emote('Toxic Fairy', 'exclamation')
        self.say("I've got my combination of potent poisonous potions ready.",
                 'Toxic Fairy', 'Fairy')
        
        self.center_on('Cosmic Fairy')
        self.startle('Cosmic Fairy')
        self.emote('Cosmic Fairy', 'exclamation')
        self.say("I swiped a special spell that the Fuzzballs developed: a blast of light that'll stun anyone who sees it.",
                  'Cosmic Fairy', 'Fairy')
        
        self.center_on('Ninja Fairy')
        self.startle('Ninja Fairy')
        self.emote('Ninja Fairy', 'exclamation')
        self.say("I'm going to rain my daggers at their feet. They'll slow to a crawl.",
                 'Ninja Fairy', 'Fairy')
        
        self.center_on('Youmu')
        self.set_cursor_state(False)
        self.say("Now?",
                 "Youmu",
                 "Youmu")
        self.say("Now! We'll hit them right as they're getting ready to move.",
                 "Ran",
                 "Ran")
        self.say("Everyone attack!",
                 "Youmu",
                 "Youmu")        

        # Enemy units move into position in response
        self.center_on('Fairy Captain')
        self.say("We're under attack?! This is the worst timing. I need some of the spell fairies up by the weasels. And you two walking trees, go defend from the south.",
                 "Fairy Captain",
                 "Fairy")
        self.move_unit('Walking Tree F', (12,10))
        self.move_unit('Walking Tree I', (16,10))
                       
        self.say("Come on! Move! Move!",
                 "Fairy Captain",
                 "Fairy")
        
        self.move_unit('Walking Tree F', (12,12))
        self.move_unit('Walking Tree I', (16,12))

        self.say("It's so hard to direct these without a Kodama around!",
                 "Fairy Captain",
                 "Fairy")
        
        self.fade_to_color('black', 1)


        self.set_unit_pos('Walking Tree D', (10,8))
        self.set_unit_pos('Walking Tree E', (11,7))
        self.set_unit_pos('Fairy Captain', (12,7))
        self.set_unit_pos('Healer Fairy C', (13,7))
        self.set_unit_pos('Walking Tree G', (14,7))
        self.set_unit_pos('Walking Tree H', (15,8))


        self.set_unit_pos('Walking Tree F', (15,25))
        self.set_unit_pos('Walking Tree I', (13,27))
        self.set_unit_pos('Cosmic Fairy', (22,9))
        self.set_unit_pos('Sealing Fairy', (24,9))
        
        self.fade_from_color('black', 1)
        
        self.say("I hope we can hold up. Kotone's not going to be happy if we lose our reinforcements.",
                 "Fairy Captain",
                 "Fairy")
        self.center_on_coords((27,23))

        
        self.set_cursor_state(True)
        self.set_stats_display(True)
        
class Turn2MAE(MapActionEvent):

    def __init__(self):
        trigger_list = [
            TurnNumTrigger(2),
            UnitAliveTrigger('Fairy Captain',True),
            UnitAliveTrigger('Healer Fairy C',True)
        ]
        MapActionEvent.__init__(self, trigger_list)

    def execute(self):

        # Fairy captain being confident in her units

        self.center_on('Fairy Captain')
        self.say("They don't look that tough.",
                 "Fairy Captain",
                 "Fairy")
        self.say("I wouldn't be so sure. I've heard rumors of a sorcerer that can level an entire forest from halfway across Gensokyo!",
                 "Healer Fairy",
                 "Healer Fairy")
        self.emote('Fairy Captain', 'exclamation')
        self.say("What?! You've got to be joking!",
                 "Fairy Captain",
                 "Fairy")


class Turn6MAE(MapActionEvent):

    def __init__(self):
        trigger_list = [
            TurnNumTrigger(6),
            UnitAliveTrigger('Fairy Captain',True),
            UnitAliveTrigger('Healer Fairy C',True)
        ]
        MapActionEvent.__init__(self, trigger_list)

    def execute(self):


        # Fairy captain commenting on how hard it is to run the show without a Kodama Lord

        self.center_on('Fairy Captain')
        self.say("Walking trees! No! Don't go over there!",
                 "Fairy Captain",
                 "Fairy")
        self.emote('Fairy Captain', 'annoyed')
        self.say("Argh! What are you doing?! Don't attack her yet!",
                 "Fairy Captain",
                 "Fairy")
        self.say("If we only had a Kodama Lord to lead the way!",
                 "Healer Fairy",
                 "Healer Fairy")
        self.say("You're right. I never expected it'd be this frustrating without one.",
                 "Fairy Captain",
                 "Fairy")




class FiveFairiesDeadMAE(MapActionEvent):

    def __init__(self):
        trigger_list = [
            UnitAliveTrigger('Fairy Captain',True),
            UnitAliveTrigger('Ninja Fairy',False),
            UnitAliveTrigger('Cosmic Fairy',False),
            UnitAliveTrigger('Dazzling Fairy',False),
            UnitAliveTrigger('Toxic Fairy',False),
            UnitAliveTrigger('Sealing Fairy',False)
        ]
        MapActionEvent.__init__(self, trigger_list)

    def execute(self):

        # All five fairies are defeated. FC expresses her disbelief

        self.center_on('Fairy Captain')
        self.say("What?! They defeated the five fairies? We're in big trouble now!",
                 "Fairy Captain",
                 "Fairy")


class PostMissionMAE(MapActionEvent):

    def __init__(self):
        triggers = []
        MapActionEvent.__init__(self,triggers)

    def pre_exec(self):

        self.set_cursor_state(False)
        self.set_stats_display(False)
        self.remove_all_enemies()
        self.stop_music()

        self.set_unit_pos('Youmu',(14,6))

        self.set_unit_pos('Ran',(13,8))
        self.set_unit_pos('Reimu',(14,8))
        self.set_unit_pos('Marisa',(15,8))
        self.set_unit_pos('Keine',(15,9))
        self.set_unit_pos('Chen',(13,9))

        self.set_unit_pos('Fairy Captain',(13,2))

    def execute(self):

        # Fairy Captain withdraws from battle map ahead of hero party

        self.center_on('Fairy Captain')
        self.say('They got ALL of us?! I have to warn Kotone!',
                'Fairy Captain',
                'Fairy')
        self.move_unit('Fairy Captain', (13, -1))
        self.kill_unit('Fairy Captain')

        self.center_on('Marisa')
        self.say("No time to wait! We'll be right behind you!",
                'Marisa',
                'Marisa')
        